/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.TypePegawaiDao;
import com.portofolio.dto.TypePegawaiDto;
import com.portofolio.entity.TypePegawai;
import com.portofolio.entity.vo.TypePegawaiId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class TypePegawaiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private TypePegawaiDao typePegawaiDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(TypePegawaiDto typePegawaiDto) {
		result.clear();
		TypePegawaiId id = new TypePegawaiId();
		Integer kdTypePegawai =getIdTerahir(TypePegawai.class.getSimpleName());
		id.setKdTypePegawai(kdTypePegawai);
		id.setKdProfile(getKdProfile());
		TypePegawai typePegawai = CommonUtil.findOne(typePegawaiDao, id);
		if (CommonUtil.isNullOrEmpty(typePegawai)) {
			typePegawai = new TypePegawai();
			BeanUtils.copyProperties(typePegawaiDto, typePegawai);
			typePegawai.setNoRec(generateUuid32());
			typePegawai.setVersion(1);
			typePegawai.setId(id);
			typePegawai = typePegawaiDao.save(typePegawai);
			result.put("typePegawai", typePegawai);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("typePegawai.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(TypePegawaiDto typePegawaiDto, Integer kdTypePegawai, Integer version) {
		result.clear();
		TypePegawaiId id = new TypePegawaiId();
		id.setKdTypePegawai(kdTypePegawai);
		id.setKdProfile(getKdProfile());
		TypePegawai typePegawai = CommonUtil.findOne(typePegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(typePegawai)) {
			if (version < typePegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(typePegawaiDto, typePegawai);
			typePegawai.setVersion(version);
			typePegawai = typePegawaiDao.save(typePegawai);
			result.put("typePegawai", typePegawai);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaTypePegawai,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaTypePegawai)) {
			pageRes = typePegawaiDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = typePegawaiDao.findAllList(getKdProfile(), namaTypePegawai, statusEnabled, pageReq);
		}
		result.put("typePegawai", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdTypePegawai(Integer kdTypePegawai) {
		result.clear();
		result.put("typePegawai", typePegawaiDao.findByKdTypePegawai(getKdProfile(), kdTypePegawai, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdTypePegawai, Integer version) {
		result.clear();
		TypePegawaiId id = new TypePegawaiId();
		id.setKdTypePegawai(kdTypePegawai);
		id.setKdProfile(getKdProfile());
		TypePegawai typePegawai = CommonUtil.findOne(typePegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(typePegawai)) {
			if (version < typePegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			typePegawai.setStatusEnabled(false);
			typePegawai.setVersion(version);
			typePegawai = typePegawaiDao.save(typePegawai);
			result.put("typePegawai", typePegawai);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
